import { LitElement } from 'lit';
declare type Elements = {
    [tagName: string]: string;
};
interface Model {
    id: string;
    element: string;
    [key: string]: any;
}
declare type Item = {
    markup: string;
    elements: Elements;
    models: Model[];
};
declare type Config = {
    item: Item;
    options?: {
        role: 'student' | 'instructor';
    };
};
declare type PkgResolution = {
    tagName: string;
    printTagName?: string;
    pkg: string;
    url: string;
    module: boolean;
};
declare type ResolverFn = (tagName: string, pkg: string) => Promise<PkgResolution>;
export declare class FailedEl extends HTMLElement {
    connectedCallback(): void;
}
export declare class PiePrint extends LitElement {
    static styles: import("lit").CSSResultGroup;
    constructor();
    set missingElement(c: any);
    get missingElement(): any;
    createRenderRoot(): this;
    private _resolve;
    private _loadResolutions;
    private _missingElement;
    private mathRenderingModuleUrlImported;
    private _applyData;
    set resolve(fn: ResolverFn);
    private _config;
    private _resolutions;
    private _printItem;
    private _floatItem;
    get config(): Config;
    /**
     * TODO: I'm not sure if this is the best path, as it may be nice to
     * provide some ui feedback when setting up the resolutions etc.
     * Will get us over the hump for now.
     */
    set config(value: Config);
    private renderMath;
    connectedCallback(): void;
    updated(changedProperties: Map<string, any>): Promise<void>;
    render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'pie-print': PiePrint;
    }
}
export {};
//# sourceMappingURL=pie-print.d.ts.map